<?php
/*
   Plugin Name: SMu Manual DoFollow
   Plugin URI: http://blog.murawski.ch/2010/09/wordpress-manual-dofollow-plugin/
   Description: You can Choose from all Commenters, if there link has nofollow or dofollow.
   Version: 1.7.0
   Author: Stefan Murawski
   Author URI: http://blog.murawski.ch/

   Copyright (c) 2010 Stefan Murawski <blog@murawski.ch>
   All rights reserved.

   This program is distributed under the GNU General Public License, Version 2,
   June 1991. Copyright (C) 1989, 1991 Free Software Foundation, Inc., 51 Franklin
   St, Fifth Floor, Boston, MA 02110, USA

   THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND
   ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
   WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE
   DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR
   ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES
   (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
   LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON
   ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
   (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
   SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*/

$smu_dofollow_version = '1.7.0';
$smuoptions = get_option('smudofollow');

/*
Gegebenenfalls Neuerung
if ( is_admin() ) {
   wp_enqueue_script("jquery");
   add_action('admin_print_footer_scripts','smu_script');
   function smu_script()
   {
	?><script>jQuery("#comment-status-radio").after('<div class="misc-pub-section" id="comment-status-radio"><label class="approved"><input type="radio"<?php checked( $comment->comment_follow, "1" ); ?> name="comment_follow" value="1" />DoFollow</label><?
	?><br /><label class="spam"><input type="radio"<?php checked( $comment->comment_follow, "0" ); ?> name="comment_follow" value="0" />NoFollow</label><?
	?><br /><label class="waiting"><input type="radio"<?php checked( $comment->comment_follow, "2" ); ?> name="comment_follow" value="2" />Auto</label></div>');</script><?
   }
}
*/


function del_nofollow($ret) {
	// The replacement functions for all versions of nofollow
	$ret = str_replace(
			array(" rel='nofollow'"," rel='external nofollow'"," rel=\"nofollow\""," rel=\"external nofollow\"","nofollow"),
			array('','','','',''),
		$ret);
	return $ret;
}

function smu_task_function()
{
	global $wpdb, $smuoptions;
	$table_name = $wpdb->prefix . 'man_dofollow';
	$table_name2 = $wpdb->prefix . 'man_dofollow2';

	$wpdb->get_row("TRUNCATE ".$table_name2);
	$qry = $wpdb->get_results("SELECT a.comment_author_url FROM ".$table_name." as b LEFT JOIN ".$wpdb->comments." as a ON a.comment_author_email=b.email WHERE b.dofollow='yes' AND a.comment_type NOT IN ('pingback','trackback') AND a.comment_approved='1' AND a.comment_author_url!='' GROUP BY a.comment_author_url");
	foreach ($qry as $row)
	{
		$content = url_get_contents($row->comment_author_url,'cURL',true,$smuoptions['smudofollow_redirect']);
		$return = SMuURLCheck($content);
		$wpdb->get_row("INSERT INTO ".$table_name2." SET link='".$wpdb->escape($row->comment_author_url)."', lastcheck='".time()."', status='".$wpdb->escape($return)."'");
		if (preg_match("/".$smuoptions['smudofollow_rot1']."/",$return))
		{
			$fail++;
		}
	}

	if ($fail >= '1')
	{
		wp_mail(get_option('admin_email'),  __('URL Validation', 'smu'), __('This is a automatically notification that', 'smu'). " ".$fail." ". __('URL are invalid and should be disabled on', 'smu') ." ".admin_url("admin.php?page=smu_dolist") );
	}
}

function smu_man_urlchk()
{
	global $_GET, $smuoptions;

	if ($_GET['page2'] != '')
	{
		$content = url_get_contents(urldecode($_GET['page2']),'cURL',true,$smuoptions['smudofollow_redirect']);
		$return = SMuURLCheck($content);

		print "Status: ".$return."<br/><br/><strong>Header:</strong><br/><textarea style=\"width: 300px !important; height: 250px !important;\">".$content."</textarea>";
	}
	else
	{
		print __('No URL provided?','su');
	}
}

function smu_nodofollow($ret)
{
	// This is the functions, who check the automatism and the manually set status
	global $wpdb, $comment, $smuoptions;
	$table_name = $wpdb->prefix . 'man_dofollow';

	if ($smuoptions['smudofollow_target'] == '1') { $ret = preg_replace("/<a /","<a target=\"_blank\" ",$ret); }
	if ($smuoptions['smudofollow_target'] == '2') { $ret = preg_replace("/<a /","<a onclick=\"window.open(this.href,'_blank');return false;\" ",$ret); }

	// if trackback or pingback, set dofollow and no DB Querys
	if ($comment->comment_type == "pingback" || $comment->comment_type == "trackback")
	{
		if ($smuoptions['smudofollow_tbfollow'] == '1') { $ret = del_nofollow($ret); }
		return $ret;
	}
	else
	{
		// We go and check the manually database for an entry for the user
		$queryString="SELECT dofollow FROM ".$table_name." WHERE email='".$wpdb->escape($comment->comment_author_email)."' LIMIT 1";
		$link_status = $wpdb->get_var($queryString);
		if ($link_status == "yes")
		{
			//Dofollow manuall entry
			$ret = del_nofollow($ret);
			return $ret;
		}
		elseif ($link_status == "no")
		{
			//Nofollow manuall entry
			return $ret;
		}
		elseif ($smuoptions['smudofollow_automation'] == '1')
		{
			// Check how many comments the user has allredy (automatism)
			$queryString="SELECT COUNT(comment_author_url) as comments FROM ".$wpdb->comments." WHERE comment_author_url='".$wpdb->escape($comment->comment_author_url)."'";
			$comments_count = $wpdb->get_var($queryString);

			if ($comments_count >= $smuoptions['smudofollow_commentsmenge'])
			{
				// More then 3 comments = DoFollow
				$ret = del_nofollow($ret);
				return $ret;
			}
			else
			{
				// Less then 3 comments, NoFollow
				return $ret;
			}
		}
		else
		{
			return $ret;
		}
	}
}

function SMu_Activation()
{
	global $wpdb;
	global $wp_db_version;

	// Create Table for manually status of the Follow Attribute
	$table_name = $wpdb->prefix . "man_dofollow";
	$sql_createtable = "CREATE TABLE IF NOT EXISTS `" . $table_name . "` (
		`id` MEDIUMINT(9) NOT NULL AUTO_INCREMENT,
		`email` VARCHAR(100),
		`dofollow` ENUM ('no','yes') DEFAULT 'no',
		PRIMARY KEY (`id`));";
	$wpdb->get_row($sql_createtable);


	$sql_createtable = "CREATE TABLE IF NOT EXISTS `" . $table_name . "2` (
  		`id` mediumint(9) NOT NULL AUTO_INCREMENT,
  		`link` varchar(200) NOT NULL,
  		`lastcheck` int(11) NOT NULL,
		`status` varchar(100) NOT NULL,
  		PRIMARY KEY (`id`));";
	$wpdb->get_row($sql_createtable);

	// Bugfix 0.1.5 Nchstes Aktivieren
	@wp_clear_scheduled_hook('smu_task_hook');
	@wp_unschedule_event('smu_task_hook');

	SMu_UpdateOptions();
}

function SMu_Deactivation()
{
	global $wpdb, $smuoptions;
	global $wp_db_version;

	// Create Table for manually status of the Follow Attribute
	$table_name = $wpdb->prefix . "man_dofollow";
	$sql_createtable = "DROP TABLE IF EXISTS " . $table_name . ";";

	@wp_clear_scheduled_hook('smu_task_hook');
	@wp_unschedule_event('smu_task_hook');
	// Nicht lschen, damit diese erhlten bleiben bei einem Update!
	//delete_option('smudofollow');
	wp_cache_flush();

}

function SMu_UpdateOptions()
{
	 include(plugin_dir_path( __FILE__ ).'pages/int_options.php');
}

function smu_add_pages()
{
	global $wpdb, $smuoptions, $smu_dofollow_version;
	// translation includes
	if (function_exists('load_plugin_textdomain'))
	{
        	load_plugin_textdomain('smu', PLUGINDIR.'/'.dirname(plugin_basename(__FILE__)).'/languages', dirname(plugin_basename(__FILE__)).'/languages');
	}

	$table_name = $wpdb->prefix . 'man_dofollow';

	// check if table exists
	if ($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name)
	{
		SMu_Activation();
	}
	if ($smuoptions['smudofollow_version'] != $smu_dofollow_version)
	{
		SMu_UpdateOptions;
	}

	// Add adminmenu
	$mincap = 'level_8';
	add_menu_page('Manuall DoFollow', 'SMu DoFollow', $mincap, __FILE__, 'smumenu');
	add_submenu_page(__FILE__, __('DoFollow Links', 'smu'), __('DoFollow User', 'smu'), $mincap, 'smu_douser', 'SMuDoUser');
	add_submenu_page(__FILE__, __('DoFollow Links', 'smu'), __('DoFollow Links', 'smu'), $mincap, 'smu_dolist', 'SMuDoList');
	add_submenu_page(__FILE__, __('NoFollow Links', 'smu'), __('Stats', 'smu'), $mincap, 'smu_stats', 'SMuStats');
	add_submenu_page(__FILE__, __('Settings'), __('Settings'), $mincap, 'smu_options', 'SMuOptions');
	add_submenu_page(__FILE__, 'Changelog','Changelog', $mincap, 'smu_changelog', 'SMuChangeLog');
}

function smumenu()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "man_dofollow";

	// if the user want to save something
	if (isset($_POST['smusave']))
	{
		// delete everythin in the manual table
		$wpdb->get_row("TRUNCATE ".$table_name);
		foreach($_POST as $var => $wert)
		{
			// if a user has a m anuall status set set db entry to yes or no
			if (substr($var,0,12) == "smudofollow_")
			{
				$mailaddi = rtrim(substr($var,12,72));
				$qry = $wpdb->get_row("INSERT INTO ".$table_name." SET email='".str_replace("_",".",mysql_real_escape_string($mailaddi))."', dofollow='".mysql_real_escape_string($wert)."'");
			}
		}
		wp_cache_flush();
	}

	if ($_GET['smu_action'] == 'douser')
	{
		SMuDoUser();
	}
	elseif ($_GET['smu_action'] == 'nolist')
	{
		SMuNoList();
	}
	elseif ($_GET['smu_action'] == 'smu_options')
	{
		SMuOptions();
	}
	elseif ($_GET['smu_action'] == 'url_check')
	{
		smu_man_urlchk();
	}
	elseif ($_GET['smu_action'] == 'comdosmu')
	{
		smu_com('yes');
	}
	elseif ($_GET['smu_action'] == 'comnosmu')
	{
		smu_com('no');
	}
	elseif ($_GET['smu_action'] == 'commtemplate')
	{
		include(plugin_dir_path( __FILE__ ).'pages/commtemplate.php');
	}
	elseif ($_GET['smu_action'] == 'changelog')
	{
		SMuChangeLog();
	}
	else
	{
		global $smuoptions;
		if (!isset($_GET['smumenge']))
		{
			$menge = $smuoptions['smudofollow_showmenge'];
			if ($menge == '') { $menge = '2'; }
		}
		else { $menge = (integer)$_GET['smumenge']; }
		SMuMain($menge);
	}
}

function smu_com($action)
{
	global $wpdb, $_GET;
	$table_name = $wpdb->prefix . "man_dofollow";
	$comauthmail = $wpdb->get_var("SELECT comment_author_email FROM ".$wpdb->comments." where COMMENT_id='".mysql_real_escape_string($_GET['c'])."' LIMIT 1");

	$wpdb->get_row("DELETE FROM ".$table_name." WHERE `email`='".str_replace("_",".",mysql_real_escape_string($comauthmail))."' LIMIT 1");
	$wpdb->get_row("INSERT INTO ".$table_name." SET `email`='".str_replace("_",".",mysql_real_escape_string($comauthmail))."', `dofollow`='".$action."'");

	echo "<meta http-equiv=\"refresh\" content=\"0; url=".wp_get_referer()."\">";
}

function smu_comment_row_actions($t)
{
	preg_match("/c=([0-9]*)\&.*approvecomment(.*)' class/",$t['approve'],$ausgabe);
	$t['smu_dofollow'] = "<a href='admin.php?page=manuall-dofollow/manual_dofollow.php&#038;smu_action=comdosmu".$ausgabe[2]."&#038;c=".$ausgabe[1]."' class='vim-a' title='" . __('Give DoFollow to author', 'smu') . "'>DoFollow</a>";
	$t['smu_nofollow'] = "<a href='admin.php?page=manuall-dofollow/manual_dofollow.php&#038;smu_action=comnosmu".$ausgabe[2]."&#038;c=".$ausgabe[1]."' class='vim-a' title='" . __('Give NoFollow to author', 'smu') . "'>NoFollow</a>";

	return $t;
}

function SMuUpdateFuncs($name,$wert)
{
	global $smuoptions,$_POST;
	//check if a new version have a unset option or if there is coming an update from Options page
	if ($smuoptions[$name] == '' && $_POST[$name] == '') { $smuoptions[$name] = $wert; }
	elseif ($_POST['smu_optionsave'] == 'true')
	{
		// Checkbox have nothing in, post a NULL
		if ($_POST[$name] == '') { $smuoptions[$name] = '0'; }
		else { $smuoptions[$name] = $_POST[$name]; }
	}
}

function SMuChangeLog()
{
	$fp = fopen(plugin_dir_path( __FILE__ ).'readme.txt',"r");
	$inhalt = fread($fp,filesize(plugin_dir_path( __FILE__ ).'readme.txt'));
	fclose($fp);
	$ch = explode("== Changelog ==\n\n",$inhalt);
	$ch = explode("\n== Upgrade Notice ==",$ch[1]);

	$changelog = preg_replace("/\* (.*?)\n/","<li>$1</li>",$ch[0]);
	$changelog = preg_replace("/= (.*?) =/","</lu><strong>= $1 =</strong><lu>",$changelog);
	$changelog = preg_replace("/`(.*?)`/","<span style=\"background-color: #E1E1E1;\">$1</span>",$changelog);

	$changelog = preg_replace("/\[(.*?)\]\((.*?)\"(.*?)\"\)/","<a href=\"$2\" rel=\"external nofollow\" alt=\"$3\">$1</a>",$changelog);
	print "<div class='wrap'><h2>". __('Suggestion and Feedback', 'smu') ."</h2>". __('If you have a feature request or feedback about a bug, please report it to me on <a href="http://blog.murawski.ch/2010/09/wordpress-manual-dofollow-plugin/" rel="external" alt="IT Bl&ouml;gg - Wordpress Manual DoFollow Plugin">IT Bl&ouml;gg - Wordpress Manual DoFollow Plugin</a>.', 'smu') ."
	<h2>Changelog</h2>". $changelog."</div>";
}

function SMuOptions()
{
	global $smuoptions;
	// Save Options if a update comes
	if ($_POST['smu_optionsave'] == "true")
	{
		SMu_UpdateOptions();
		$saved = '1';
	}

	include(plugin_dir_path( __FILE__ ).'pages/options.php');
}

function SMuURLCheck($content)
{
	global $smuoptions;
	if (preg_match("/\/xmlrpc.php/",$content))
	{
		return "<font color=\"". $smuoptions['smudofollow_gruen1'] . "\">" . __('valid', 'smu') . " (Wordpress)</font>";
	}
	elseif (preg_match("/HTTP\/1.1 200/",$content))
	{
		return "<font color=\"". $smuoptions['smudofollow_gruen1'] . "\">" . __('valid', 'smu') . "</font>";
	}
	elseif (preg_match("/HTTP\/1.1 404/",$content))
	{
		return "<font color=\"". $smuoptions['smudofollow_rot1'] . "\">" . __('not valid', 'smu') . "</font>";
	}
	elseif ($content == "")
	{
		return "<font color=\"". $smuoptions['smudofollow_rot1'] . "\">" . __('Domain not found', 'smu') . "</font>";
	}
	elseif ((preg_match("/HTTP\/1.1 301/",$content) OR preg_match("/HTTP\/1.1 302/",$content)))
	{
		if ($smuoptions['smudofollow_redirect'] == '1')
		{
			return "<font color=\"". $smuoptions['smudofollow_gruen1'] . "\">" . __('redirect', 'smu') . "</font>";
		}
		else
		{
			return "<font color=\"". $smuoptions['smudofollow_rot1'] . "\">" . __('redirect', 'smu') . "</font>";
		}
	}

	else
	{
		return "<font color=\"". $smuoptions['smudofollow_rot1'] . "\">" . __('unknown error', 'smu') . "</font>";
	}
}

function SMuDoUser()
{
	global $wpdb, $smuoptions;
	$table_name = $wpdb->prefix . "man_dofollow";


	print "<div class='wrap'><h2>" . __('List of all DoFollow Users', 'smu') . "</h2>";
	print "<table class='widefat'><thead><tr>
	<th scope='col'>" . __('Count', 'smu') . "</th>
	<th scope='col'>" . __('User', 'smu') . "</th>
	<th scope='col'>" . __('E-Mail', 'smu') . "</th>
	<th scope='col'>" . __('Why DoFollow', 'smu') . "</th>
	</tr></thead>
	<tbody id='the-list'>";

	$qry = $wpdb->get_results("SELECT max(a.comment_author) as comment_author, a.comment_author_email, COUNT(a.comment_ID) as anz, b.dofollow FROM ".$table_name." as b LEFT JOIN ".$wpdb->comments." as a ON a.comment_author_email=b.email WHERE b.dofollow!='no' AND a.comment_type NOT IN ('pingback','trackback') AND a.comment_approved='1' AND a.comment_author_url!='' GROUP BY a.comment_author_email ORDER BY anz DESC");
	foreach ($qry as $row)
	{
		if ($row->dofollow == "yes" OR ($smuoptions['smudofollow_automation'] == '1' AND $row->anz >= $smuoptions['smudofollow_commentsmenge']))
		{
			print "<tr><td><a onclick=\"window.open('" . get_option('siteurl') . "/wp-admin/edit-comments.php?s=".str_replace("@","%40",$row->comment_author_email)."&amp;mode=detail&amp;comment_status=all&amp;comment_type=comment', 'Wordpress Comments (".$row->comment_author.")', 'scrollbars=yes,status=yes,location=no,toolbar=no,menubar=no,statusbar=yes'); return false\" href=\"" . get_option('siteurl') . "/wp-admin/edit-comments.php?s=".str_replace("@","%40",$row->comment_author_email)."&amp;mode=detail&amp;comment_status=all&amp;comment_type=comment\">".$row->anz."</a></td><td>".$row->comment_author."</td><td>".$row->comment_author_email."</td>";
			if ($row->dofollow == "yes") { print "<td>" . __('Manually', 'smu') . "</td>"; }
			else { print "<td>" . __('Automatism', 'smu') . "</td>"; }
			print "</tr>";
		}
	}
	print "</tbody></table>";

}

function SMuDoList()
{
	global $wpdb, $smuoptions;
	$table_name = $wpdb->prefix . "man_dofollow";
	$table_name2 = $wpdb->prefix . "man_dofollow2";

	if ($_GET['edititem'] != '')
	{
		print "<div class='wrap'><h2>" . __('Change URL for an User behind Comments', 'smu') . "</h2><form method=\"POST\" action=\"" . get_option('siteurl') . "/wp-admin/admin.php?page=smu_dolist&saveitem=".$_GET['edititem']."\">
		<table class=\"form-table\">
		<tr>
			<th valign=\"top\">" . __('Original', 'smu') . ":</th>
			<td><input size=\"50\" class=\"disabled\" type=\"text\" name=\"orginalstring\" value=\"".$_GET['edititem']."\" /></td>
		</tr>
		<tr>
			<th valign=\"top\">" . __('Revised', 'smu') . ":</th>
			<td><input size=\"50\" class=\"enabled\" type=\"text\" name=\"newstring\" value=\"\" /></td>
		</tr></table>
		<input type=\"submit\" name=\"smusave999\" value=\"" . __('Save', 'smu') . "\" /></form>";
	}
	elseif ($_GET['urlitem'] != '')
	{
		print "<div class='wrap'><h2>" . __('Send Info to User that his URLs have know DoFollow Status', 'smu') . "</h2><form method=\"POST\" action=\"" . get_option('siteurl') . "/wp-admin/admin.php?page=smu_dolist&sendmail=1\">
		<table class=\"form-table\">
		<tr>
			<th valign=\"top\">TO:</th>
			<td><input size=\"50\" class=\"enabled\" type=\"text\" name=\"toadress\" value=\"".$_GET['infomail']."\" /></td>
		</tr>
		<tr>
			<th valign=\"top\">" . __('Message', 'smu') . ":</th>
			<td><textarea cols=\"70\" rows=\"15\" name=\"mailmessage\">";

			printf( __('Hello %s
You have left comments on the page %s with your mailadress.
In your comments the URL %s was provided.

All your comments with the URL above will have DoFollow Status on our page for the future from now on.
Regards.','smu'), $_GET['authu'], get_option('siteurl'), $_GET['urlitem']);

			print "</textarea></td>
		</tr></table>
		<input type=\"submit\" name=\"smusave998\" value=\"" . __('Send Mail to commentator', 'smu') . "\" /></form>";
	}
	else
	{
		if ($_GET['delitem'] != '')
		{
	    	$qry = $wpdb->get_results("UPDATE ".$wpdb->comments." SET comment_author_url='' WHERE comment_author_url='".mysql_real_escape_string($_GET['delitem'])."'");
		}
		elseif ($_GET['saveitem'] != '' && $_POST['newstring'] != '')
		{
			$qry = $wpdb->get_results("UPDATE ".$wpdb->comments." SET comment_author_url='".mysql_real_escape_string(urldecode($_POST['newstring']))."' WHERE comment_author_url='".mysql_real_escape_string(urldecode($_POST['orginalstring']))."'");
		}
		elseif ($_POST['smusave998'] != '')
		{
			wp_mail($_POST['toadress'],  __('DoFollow Status on your link', 'smu'), urldecode($_POST['mailmessage']) );
			print __('Mail successfully send to user','smu')."<br/>";
		}

		print "<div class='wrap'><h2>" . __('List of all DoFollow Links', 'smu') . "</h2>";
		print "<script>
	function check()
	{
		var janein=confirm(\"" . __('Dead URLs should be deleted from the list for SEO reason, but it\'s possible that the site is only down temporary.\nThis action can not be reversed and you should be sure that you want to to this!\n\nDo you really want to delete this URL (exact writing) from all comments?','smu') . "\");
		if (janein==false)
		return false;
		else
		return true;
	}

	</script><table class='widefat'><thead><tr>
		<th scope='col'>" . __('Count', 'smu') . "</th>
		<th scope='col'>" . __('User', 'smu') . "</th>
		<th scope='col'>URL</th><th scope='col'>";

		if ($smuoptions['smudofollow_urlcheck'] != '0') { print __('URL Validation', 'smu'); }

		print "</th><th></th><th scope='col'>" . __('Why DoFollow', 'smu') . "</th></tr></thead><tbody id='the-list'>";

		if ($smuoptions['smudofollow_urlcheck'] == '4' OR $smuoptions['smudofollow_urlcheck'] == '0')
		{
			$qry = $wpdb->get_results("SELECT max(a.comment_author) as comment_author, a.comment_author_url, COUNT(a.comment_ID) as anz, max(a.comment_author_email) as mail, b.dofollow FROM ".$table_name." as b LEFT JOIN ".$wpdb->comments." as a ON a.comment_author_email=b.email WHERE b.dofollow!='no' AND a.comment_type NOT IN ('pingback','trackback') AND a.comment_approved='1' AND a.comment_author_url!='' GROUP BY a.comment_author_url ORDER BY anz DESC");
		}
		else
		{
			$qry = $wpdb->get_results("SELECT max(a.comment_author) as comment_author, a.comment_author_url, COUNT(a.comment_ID) as anz, c.lastcheck, c.status, max(a.comment_author_email) as mail, b.dofollow FROM ".$table_name." as b LEFT JOIN ".$wpdb->comments." as a ON a.comment_author_email=b.email LEFT JOIN ".$table_name2." as c ON c.link=a.comment_author_url WHERE b.dofollow!='no' AND a.comment_type NOT IN ('pingback','trackback') AND a.comment_approved='1' AND a.comment_author_url!='' GROUP BY a.comment_author_url ORDER BY anz DESC");
		}
		foreach ($qry as $row)
		{
			if ($row->dofollow == "yes" OR ($smuoptions['smudofollow_automation'] == '1' AND $row->anz >= $smuoptions['smudofollow_commentsmenge']))
			{

				print "<tr><td>".$row->anz."</td><td>".$row->comment_author."</td><td><a href='".$row->comment_author_url."' target='_blank'>".$row->comment_author_url."</a></td><td>";

				if ($smuoptions['smudofollow_urlcheck'] == '4')
				{
					$content = url_get_contents($row->comment_author_url,'cURL',true,0);
					print SMuURLCheck($content);
				}
				elseif ($smuoptions['smudofollow_urlcheck'] != '0')
				{
					unset($end);
					if ($row->status != '')
					{
						print $row->status." (";
						$diff = time() - $row->lastcheck;
						$days = date('j', $diff);
						$hours = date('G', $diff);
						$minutes = date('i', $diff);
						unset($days);
						if ($days != '0' AND $days != '') { $end = $days."d "; }
						if ($hours != '0' AND $hours != '') { $end .= $hours."h "; }
						if ($minutes != '0' AND $minutes != '') { $end .= $minutes."m"; }
						printf( __('Last Check %s ago', 'smu'), $end );
						print ")";
					}
					else { print "(" . __('not checked yet', 'smu') . ")"; }

				}

				print "</td><td><a href='admin.php?page=manuall-dofollow/manual_dofollow.php&amp;smu_action=url_check&amp;page2=".$row->comment_author_url."'><img src=\"".plugins_url('manuall-dofollow/images/check.gif') ."\" alt=\"". __ ('Check manual the status about the URL','smu')."\" border=\"0\" /></a>&nbsp;<a href=\"" . get_option('siteurl') . "/wp-admin/admin.php?page=smu_dolist&edititem=".urlencode($row->comment_author_url)."\"><img src=\"".plugins_url('manuall-dofollow/images/note.png') ."\" alt=\"". __ ('Edit Comment URL','smu')."\" border=\"0\" /></a>&nbsp;<a href=\"" . get_option('siteurl') . "/wp-admin/admin.php?page=smu_dolist&authu=".$row->comment_author."&infomail=".$row->mail."&urlitem=".urlencode($row->comment_author_url)."\"><img src=\"".plugins_url('manuall-dofollow/images/mail.png') ."\" alt=\"". __ ('Send Infomail to User about DoFollow Status','smu')."\" border=\"0\" /></a>&nbsp;<a href=\"" . get_option('siteurl') . "/wp-admin/admin.php?page=smu_dolist&delitem=".urlencode($row->comment_author_url)."\" onclick=\"return check()\"><img src=\"".plugins_url('manuall-dofollow/images/del.png') ."\" alt=\"". __ ('Delete URL from comment','smu')."\" border=\"0\" /></a></td>";
				if ($row->dofollow == "yes") { print "<td>" . __('Manually', 'smu') . "</td>"; }
				else { print "<td>" . __('Automatism', 'smu') . "</td>"; }
				print "</tr>";
			}
		}
		print "</tbody></table>";
	}
}

function SMuStats()
{
	global $wpdb;
	$table_name = $wpdb->prefix . "man_dofollow";

	print "<div class='wrap'><h2>" . __('Stats of SMu Manual DoFollow Plugin', 'smu') . "</h2>";

	$total_comments = $wpdb->get_row("SELECT count(DISTINCT comment_author_url) as totb, count(comment_author) as totc FROM ".$wpdb->comments." WHERE comment_author_email!='' AND comment_type NOT IN ('pingback','trackback') AND comment_approved='1'");
	$total_docomments = $wpdb->get_row("SELECT count(DISTINCT comment_author_url) as totb, count(comment_author) as totc FROM ".$table_name." as a LEFT JOIN ".$wpdb->comments." as b ON b.comment_author_email=a.email WHERE a.dofollow='yes' AND b.comment_author_email!='' AND b.comment_type NOT IN ('pingback','trackback') AND b.comment_approved='1'");

	print "<table class='widefat'><thead><tr>
  	<th scope='col'></th>
  	<th scope='col'>" . __('All', 'smu') . "</th>
  	<th scope='col'>DoFollow</th>
  	<th scope='col'>NoFollow</th>
	</tr></thead>
  	<tbody id='the-list'><tr><td>" . __('Comments with URLs', 'smu') . "</td><td>" . $total_comments->totc . "</td><td>" . $total_docomments->totc . "</td><td>" . ( $total_comments->totc - $total_docomments->totc ) . "</td></tr>
	<tbody id='the-list'><tr><td>" . __('Unique Comment URLs', 'smu') . "</td><td>" . $total_comments->totb . "</td><td>" . $total_docomments->totb . "</td><td>" . ( $total_comments->totb - $total_docomments->totb ) . "</td></tr>
	</tbody></table>";

}

function url_get_contents($url,$useragent='cURL',$headers=false,$follow_redirects='0',$debug=false)
{
	$ch = curl_init();
	curl_setopt($ch, CURLOPT_URL,$url);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER,1);
	curl_setopt($ch, CURLOPT_USERAGENT, $useragent);
	curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
	if ($headers==true) { curl_setopt($ch, CURLOPT_HEADER,1); }
	if ($headers=='headers only') { curl_setopt($ch, CURLOPT_NOBODY ,1); }
	if ($follow_redirects=='1') { curl_setopt($ch, CURLOPT_FOLLOWLOCATION, 1); }
	if ($debug==true)
	{
		$result['contents']=curl_exec($ch);
		$result['info']=curl_getinfo($ch);
	}
	else { $result=curl_exec($ch); }
	curl_close($ch);
	return $result;
}


function SMuMain($menge)
{
	include(plugin_dir_path( __FILE__ ).'pages/main.php');
}

// Generating the Settings link for the Plugin list
function SMuPluginLink($links, $file)
{
	if ($file == plugin_basename(__FILE__))
	{
		$links[] = '<a href="' . admin_url("admin.php?page=smu_options") . '">'. __('Settings') .'</a>';
	}
	return $links;
}

function smu_wp_new_comment($commentdata)
{
	global $wpdb;
	if ($commentdata['comment_type'] != 'pingback' AND $commentdata['comment_type'] != 'trackback' AND $commentdata['comment_author_url'] != '')
	{
		$post_date = $wpdb->get_var("SELECT post_date FROM ".$wpdb->posts." where ID='".$commentdata['comment_post_ID']."' LIMIT 1");
		if ( (time() - strtotime($post_date)) >= (3600*24*30) )
		{
			$commentdata['comment_author_url'] = '';
		}
	}
	return $commentdata;
}

function show_dofollow_status()
{
	echo __('This Blog will give regular Commentators DoFollow Status. Implemented from', 'smu').
	" <a href=\"http://blog.murawski.ch/2010/09/wordpress-manual-dofollow-plugin/\" rel=\"external dofollow\">IT Bl&ouml;gg</a>";
}

register_activation_hook(__FILE__, 'SMu_Activation');
register_deactivation_hook(__FILE__, 'SMu_Deactivation');

if ($smuoptions['smudofollow_on'] == '1')
{
	remove_filter('pre_comment_content', 'wp_rel_nofollow',15);
	if ($smuoptions['smudofollow_f_author'] == '1') { add_filter('get_comment_author_link', 'smu_nodofollow',15); }
	if ($smuoptions['smudofollow_f_comment'] == '1') { add_filter('comment_text', 'smu_nodofollow', 15); }
	if ($smuoptions['smudofollow_hideurl'] == '1') { add_action('preprocess_comment', 'smu_wp_new_comment'); }
	if ($smuoptions['smudofollow_credits'] == '1') { add_action('comment_form', 'show_dofollow_status'); }
}

add_action('admin_menu', 'smu_add_pages');
add_filter('plugin_action_links', 'SMuPluginLink', 10, 2);
add_filter('comment_row_actions', 'smu_comment_row_actions');

?>